$!===========================================================================
$! VAX/VMS V5.0 - V5.1-1 patch for MONITOR to enable the disabled classes:
$!
$!	ETHERNET, JDEVICE, VMS1, VMS2, and VMS3
$!
$! Copy the image SYS$SYSTEM:MONITOR.EXE into your working directory,
$! execute this file as a command file (@ it), define the logical name
$! MONITOR to specify the name of your copy of MONITOR and then you're
$! ready to go.
$!
$! Note: MONITOR ETHERNET uses promiscuous mode and therefore requires
$!	 PHY_IO privilege and only ONE user can MONITOR ETHERNET at a time.
$!
$! To connect to the ethernet device, the codes uses the first successful
$! channel it gets from the following:
$!	1) translation of NI$DEVICE
$!	2) XEA0:
$!	3) XQA0:
$!
$! 29-Mar-88 Simon Hackett
$!		modified for version V4.6 of VMS (and works fine for V4.7)
$! 11-Oct-89 Michael Kimura (mnk@rdac.hac.com)
$!		modified for version V5.1-1 of VMS
$!===========================================================================
$!
$ patch monitor.exe
!
! Enable class VMS2
!
replace 6070+348
211
exit
11
exit
!
! Enable class VMS3
!
replace 6070+39c
211
exit
11
exit
!
! Enable class JDEVICE
!
replace 6070+498
235
exit
35
exit
!
! Enable class VMS1
!
replace 6070+594
211
exit
11
exit
!
! Enable class ETHERNET
!
replace 6070+63c
211
exit
11
exit
!
! Make protocol valid (6006) reserved for customer use
!
replace 251fc+9e
0
exit
0660
exit
!
! Make NI_FIND_COUNTER return success even if counter is not found.
!
! NI_FIND_COUNTER erroneously scans CTRBUF too far since it uses
! CTRDSC.DSC$W_LENGTH (which is fixed at 512) as CTRLEN instead of
! the length returned in the IOSB in the call to $QIOW in
! NI_CONVERT_DEVICE_COUNTERS.  Counter NMA$C_CTLIN_LBE is not returned
! in the buffer so NI_FIND_COUNTER scans too far and runs into a
! counter ID of 0 which it sees as having a 0 width counter and exits
! with failure.
!
replace/ins 24760+2d9+38
'beql 24ab1'
exit
'beql 24a9d'
exit
!
replace/ins 24760+2d9+6a
'brb 24ab1'
exit
'brb 24aad'
exit
!
update
exit
$ exit


