Article 25571 of comp.os.vms:
Relay-Version: VMS News - V6.0-3 14/03/90 VAX/VMS V5.4; site arizona.edu
Path: arizona.edu!arizona!noao!ncar!ames!agate!stanford.edu!rock!epa-rtp!ralph.rtpnc.epa.gov!rbn
Newsgroups: comp.os.vms
Subject: Re: Re-formatting F$GETJPI(pid,"CPUTIM")
Message-ID: <1992May5.141845.1547@rtpnc.epa.gov>
From: rbn@ralph.rtpnc.epa.gov (Bob Boyd)
Date: 5 May 92 14:18:45 GMT
Sender: usenet@rtpnc.epa.gov
References: <9205050736.AA09780@ucbvax.Berkeley.EDU>
Organization: UNISYS/Environmental Protection Agency
Nntp-Posting-Host: ralph.rtpnc.epa.gov
Lines: 58

Well, my first reply to this bombed out.  Here goes  #2

moeller@gwdgv1.dnet.gwdg.de ("GWDGV1::MOELLER") writes:
> Fred Stevens <STEVENS@RAD.HUP.UPENN.EDU> asks:
> > Is there a VMS lexical which will re-format the CPUTIM returned
> > by F$GETJPI("","CPUTIM") into an HH:MM:SS.CC string?
> 
> Not really. But there is a neat & unobvious method, which does respect
> the fact that the number returned by $GETJPI is actually *unsigned*:
> 
> $ ticks = f$getjpi("","cputim")
> $!
> $ L[ 0,32] = ticks
> $ Q[ 0,32] = -100000 * f$cvui( 0,11,L)
> $ if ticks.eq.0 then Q[0,32] = -1
> $ Q[11,32] = -100000 * f$cvui(11,11,L) + f$cvsi(11,21,Q)
> $ Q[22,32] = -100000 * f$cvui(22,10,L) + f$cvsi(22,21,Q)
> $ Q[54,10] = -1
> $!
> $ write SYS$OUTPUT f$fao("!%D",f$cvui(32,32,f$fao("!AD",8,Q)))
> 
Wolfgang,

This looks pretty nice -- would you be willing to explain the pieces of
the algorithm?  It looks like you're converting clunks to the binary 
time format using L and Q as the two halves of the quadword.  Is this
basically it?  Would like to see a complete breakdown of the steps of
the algorithm here.

Just for reference -- here is my brute force calculation that I've been
using for some time now:


$! CONVERT_CPUTIME.COM
$! convert clunks to cpu time -- values returned by f$getjpi("","CPUTIM")
$! p1 -- integer value to convert
$! p2 -- optional global symbol to return the string to.
$   cpu = p1
$   tmp_day = cpu/(24*360000)
$   tmp_hrs = cpu/360000-24*tmp_day
$   tmp_min = cpu/6000-60*(24*tmp_day+tmp_hrs)
$   tmp_sec = cpu/100-60*(60*(24*tmp_day+tmp_hrs)+tmp_min)
$   tmp_hun = cpu - 100*(60*(60*(24*tmp_day+tmp_hrs)+tmp_min)+tmp_sec)
$   cputim = f$fao("!2ZL-!2ZL:!2ZL:!2ZL.!2ZL",-
		 tmp_day,tmp_hrs,tmp_min,tmp_sec,tmp_hun)
$   if p2.nes."" 
$   then 
$	'p2' == cputim
$   else
$ 	write sys$output "CPU time:  ",cputim
$   endif
$   exit
$!Last Modified:   8-JUN-1988 10:04:43.26, By: RLB 

--
Bob Boyd                 
rbn@ralph.rtpnc.epa.gov 
Unisys/EPA               


