Article 25565 of comp.os.vms:
Relay-Version: VMS News - V6.0-3 14/03/90 VAX/VMS V5.4; site arizona.edu
Path: arizona.edu!cerritos.edu!nic.csu.net!usc!sol.ctr.columbia.edu!spool.mu.edu!agate!dog.ee.lbl.gov!ucbvax!gwdgv1.dnet.gwdg.de!moeller
Newsgroups: comp.os.vms
Subject: RE: Re-formatting F$GETJPI(pid,"CPUTIM")
Message-ID: <9205050736.AA09780@ucbvax.Berkeley.EDU>
From: moeller@gwdgv1.dnet.gwdg.de ("GWDGV1::MOELLER")
Date: 5 May 92 07:20:29 GMT
Sender: usenet@ucbvax.BERKELEY.EDU
Organization: The Internet
Article-I.D.: ucbvax.9205050736.AA09780
Lines: 21

Fred Stevens <STEVENS@RAD.HUP.UPENN.EDU> asks:
> Is there a VMS lexical which will re-format the CPUTIM returned
> by F$GETJPI("","CPUTIM") into an HH:MM:SS.CC string?

Not really. But there is a neat & unobvious method, which does respect
the fact that the number returned by $GETJPI is actually *unsigned*:

$ ticks = f$getjpi("","cputim")
$!
$ L[ 0,32] = ticks
$ Q[ 0,32] = -100000 * f$cvui( 0,11,L)
$ if ticks.eq.0 then Q[0,32] = -1
$ Q[11,32] = -100000 * f$cvui(11,11,L) + f$cvsi(11,21,Q)
$ Q[22,32] = -100000 * f$cvui(22,10,L) + f$cvsi(22,21,Q)
$ Q[54,10] = -1
$!
$ write SYS$OUTPUT f$fao("!%D",f$cvui(32,32,f$fao("!AD",8,Q)))

Wolfgang J. Moeller, GWDG, D-3400 Goettingen, F.R.Germany | Disclaimer ...
PSI%(0262)45050352008::MOELLER      Phone: +49 551 201516 | No claim intended!
Internet: moeller@gwdgv1.dnet.gwdg.de   | This space intentionally left blank.


